using System;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.Runtime;
using Autodesk.AutoCAD.Geometry;
using Autodesk.AutoCAD.ApplicationServices;
using System.Reflection;

using System.IO;
using System.Collections;
using System.Runtime.InteropServices;
using System.Diagnostics;
using Autodesk.AutoCAD.EditorInput;
using Autodesk.AutoCAD.GraphicsInterface;


namespace Lib
{
    public class MyEntityJig : EntityJig
    {
    
		Point3d mBasePt,mStartPt;
        Entity mEntity;


        public MyEntityJig(ref Entity entity, Point3d basept)
            : base(entity)
        {
            mStartPt = mBasePt = basept;

            mEntity = entity;
        }
       

		protected  override SamplerStatus Sampler(JigPrompts prompts)
		{
			JigPromptPointOptions jigOpts = new JigPromptPointOptions();
			jigOpts.UserInputControls = (UserInputControls.Accept3dCoordinates | UserInputControls.NoZeroResponseAccepted | UserInputControls.NoNegativeResponseAccepted);
            jigOpts.BasePoint = mBasePt;

            Point3d poSecondPoint;

            PromptPointResult res = prompts.AcquirePoint(jigOpts);
            poSecondPoint = res.Value;

            if (mBasePt == poSecondPoint)
                return SamplerStatus.NoChange;
            else if (mStartPt == poSecondPoint)
			    return SamplerStatus.NoChange;
		    else {
		
			        Vector3d vec;
			        vec = poSecondPoint - mStartPt;

			        Matrix3d mat;
			        mat = Matrix3d.Displacement(vec);
			        mEntity.TransformBy(mat);
        				
			        mStartPt = poSecondPoint;
            }


            return SamplerStatus.OK;		
			
			
		}
		protected override bool Update()
		{
			
			return true;  

		}
        //protected override DynamicDimensionDataCollection GetDynamicDimensionData(double dimScale)
        //{
        //    return m_dims;
        //}
		protected override void OnDimensionValueChanged(Autodesk.AutoCAD.DatabaseServices.DynamicDimensionChangedEventArgs e)
		{
			
		}
		
		public Entity GetEntity()
		{
			return Entity;
		}


        
	}
}
